#
# LinkedList.py
#
# Defines an immutable list datatype using
# a linked representation.
# 

class LinkedList:
    def __init__(self):
        self.__node = None
        
    def __str__(self):
         if self.__node == None:
             return "<>"
         else:
             return str(self.__node)
         
    def access (self, index):
        return self.__node.access (index)
        
    def append (self, e):
        res = LinkedList ()
        
        if self.__node == None:
            res.__node = ListNode(e)
        else:
            res.__node = self.__node.append (e)
            
        return res
        
    def length (self):
        if self.__node == None:
            return 0
        else:
            return self.__node.length ()
        
class ListNode:
    def __init__(self,info):
        self.__info = info
        self.__next = None
    
    def __str__(self):
        res = "<"
        current = self
        while not current == None:
            res += str(current.__info)
            if not current.__next ==  None:
                res += ", "
            current = current.__next
        res += ">"
        return res

    def getNext (self):
        return self.__next
    
    def access (self, index):
        if index == 0:
            return self.__info
        else:
            return self.__next.access (index - 1)
    
    # post: result = <self[0], self[1], ...,self[|self| - 1], value>
    # modifies nothing    
    def append (self, value):
        res = ListNode (self.__info)
        last = res
        current = self
        while not current.__next == None:
            current = current.__next
            last.__next = ListNode (current.__info)
            last = last.__next
        
        last.__next = ListNode (value)
        return res    
    
    def length (self):
        if self.__next == None:
            return 1
        else:
            return 1 + self.__next.length ()
